from testv.models.enums.input_type import InputTypeEnum
from testv.validators.rules.bids_rule import BidsRule
from tests.unit.abstract_test_case import CommonTestCase


class BidsRuleTestCase(CommonTestCase):
    def test_max_cannot_be_less_than_min(self):
        """
        Case: max_bid should always be more than min_bid
        """
        self.check_rule_error(BidsRule(input_type=InputTypeEnum.FIXED,
                                       min_bid=2,
                                       max_bid=1), "min_bid must be less than max_bid")

    def test_min_max_bids_cannot_be_same(self):
        self.check_rule_error(BidsRule(input_type=InputTypeEnum.FIXED,
                                       min_bid=1,
                                       max_bid=1), "min_bid must be less than max_bid")
