from testv.models.enums.cap_type import CapTypeEnum
from testv.validators.exceptions import ValidationException
from testv.validators.rules.cap_required_fields import CapRequiredFieldsRule
from tests.unit.abstract_test_case import CommonTestCase


class CapRequiredFieldsTestCase(CommonTestCase):
    def test_execute_validation(self):
        """
        case
        if present at least one field, cap_type should be defined as well
        """

        # cap_automatic exists
        with self.assertRaises(ValidationException):
            CapRequiredFieldsRule(cap_type=CapTypeEnum.UNDEFINED, cap_automatic=self._faker.pybool(), cap_amount=None,
                                  cap_fields={"cap_automatic": "", "cap_type": "", "cap_amount": ""}).execute()

        # cap_amount exists
        with self.assertRaises(ValidationException):
            CapRequiredFieldsRule(cap_type=CapTypeEnum.UNDEFINED, cap_automatic=None, cap_amount=self._faker.pyfloat(positive=True),
                                  cap_fields={"cap_automatic": "", "cap_type": "", "cap_amount": ""}).execute()

        # first argument is undefined, but second is OK
        try:
            CapRequiredFieldsRule(cap_type=CapTypeEnum.EVEN, cap_automatic=self._faker.pybool(), cap_amount=self._faker.pyfloat(positive=True),
                                  cap_fields={"cap_automatic": "", "cap_type": "", "cap_amount": ""}).execute()
        except Exception:
            self.fail("Unexpected exception found")
